#Agent.py
from Tools import *
import graphicDisplayGlobalVarAndFunctions as gvf
import commonVar as common

class Agent:
    def __init__(self, number,myWorldState,
                 xPos=0, yPos=0, lX =-20,rX=19, bY=-20,tY=19, agType="",
                 sector=0):
        global g
        # the environment
        self.agOperatingSets=[]
        self.number = number

        if agType == 'recipes':
            self.content=[]
            self.canMove=False
            self.maxLength=10
            self.maxSector=8
            self.factoryInWhichRecipeIs=None
            
        if agType == 'factories':
            self.sector=sector
            self.recipeWaitingList=[]
            common.orderedListOfNodes.append(self) #use to keep the order
                                                   #in output (ex. adjacency matrix)
        
        self.myWorldState = myWorldState
        self.agType=agType

        # the graph
        if gvf.getGraph() == 0: gvf.createGraph()
        g=gvf.getGraph()
        
        # the agent
        if self.agType == "factories":
         print "agent of type", self.agType, "#", self.number, \
        	      "has been created at", xPos, ",", yPos, \
        	      ' in production sector ', self.sector
         
         g.add_node(self)
         g.node[self]['sector']=sector
         gvf.colors[self]="LightGray"
         # colors at http://www.w3schools.com/html/html_colornames.asp
         gvf.pos[self]=(xPos,yPos)
         gvf.labels[self]=str(number)
         
        if self.agType == "recipes":
         print "agent of type", self.agType, "#", self.number, \
        	      "has been created"

         

    # add an operating set
    def setAnOperatingSet(self,aSet):
        self.agOperatingSets.append(aSet)

    # get operating set list
    def getOperatingSetList(self):
        return self.agOperatingSets

    # reset values
    def setNewCycleValues(self):
        pass # here is only reported for future uses

    def getAgType(self):
        return self.agType

    
    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last par

    # fill the content
    def setRecipeContent(self):
        if self.agType != "recipes": return

        if self.content != []: return

        self.canMove=True        
        length=random.randint(1,self.maxLength)
        for i in range(length+1):
            self.content.append(random.randint(1,self.maxSector))

        print "recipe %d now contains the sequence: " % (self.number), self.content
                                    

    # search for factories
    def searchForSector(self):
        if self.agType != "recipes": return

        if not self.canMove: return

        step=self.content[0] # first step to be done

        res=gvf.findNodesFromSector(step)
        if res ==[]: print "recipe %d cannot find a factory for the step of type %d"\
           % (self.number, step)
        else:        print "recipe %d found %d factory/ies for the step of type %d"\
           % (self.number, len(res), step)
        
        #for aNode in res: print aNode.sector

        if res !=[]:
            random.shuffle(res)
            print "recipe %d moving to factory %d" % (self.number,res[0].number)

            # create a link from self.factoryInWhichRecipeIs to res[0]
            # or upgrading the weight of the link 
            if self.factoryInWhichRecipeIs != None: \
                  gvf.createEdge(self.factoryInWhichRecipeIs, res[0])
            self.factoryInWhichRecipeIs=res[0]

            res[0].addToRecipeWaitingList(self) #self here is the calling recipe
        


    # check if next step can be produced
    def checkIfNextStepCanBeAccomplished(self, aRecipe):
        step=aRecipe.content[0] # next step to be done
        res=gvf.findNodesFromSector(step)

        if res != []: return True
        else:         return False
        

    # waiting list in factories
    def addToRecipeWaitingList(self, recipe):
        if self.agType != "factories": return


        recipe.canMove=False
        self.recipeWaitingList.append(recipe)
        print "factory %d waiting list contains %d recipe/s" % \
                                  (self.number,len(self.recipeWaitingList))

        #update factory label
        try:    pseudoL=g[self][self]['pseudoLabel']
        except: pseudoL=""
        gvf.labels[self]=str(self.number)+" ("+str(len(self.recipeWaitingList))+") "\
                         + "\n"+pseudoL

    # produce
    def produce(self):
        if self.agType != "factories": return

        if self.recipeWaitingList == []: return
        currentRecipe=self.recipeWaitingList[0]

        # remove the current recipe (if next sector exists or if the present
        #                            one is the last step)
        if len(currentRecipe.content)>1:
          if self.checkIfNextStepCanBeAccomplished(currentRecipe):
             self.recipeWaitingList.remove(currentRecipe)
             #if next steo cannot be accomplished, the recipe is locked here
        if len(currentRecipe.content)==1:
             self.recipeWaitingList.remove(currentRecipe)
          
        print "factory %d producing (recipe %d)" % (self.number, currentRecipe.number)

        currentRecipe.content.pop(0)
        currentRecipe.canMove=True

        if currentRecipe.content == []:
            currentRecipe.canMove=False
            print "recipe %d completed in factory %d" \
                  % (currentRecipe.number,self.number)
                                                    


